﻿B4A=true
Group=Default Group
ModulesStructureVersion=1
Type=StaticCode
Version=9
@EndOfDesignText@
'Code module
'Subs in this code module will be accessible from all modules.
Sub Process_Globals
	'These global variables will be declared once when the application starts.
	'These variables can be accessed from all modules.
'	Dim dict As Map  = CreateMap("Name":"Nom","Sex":"Sexe","Man":"Homme","Woman":"Femme","Years":"Années","Months":"Mois","Urgency":"Urgence")
	Dim dict As Map  = CreateMap()
	Dim untraslate As Map = CreateMap("DEFAULT":"", "RDEFAULT":"", "REQUIRES":"", "H":"", "AFTER":"","WINDOW":"", _
									"GROUND":"","LABEL":"")
	Dim pseudo As Map = CreateMap("CHECK":"", "TITLE":"", "TAB":"", "SECTION":"")

'	Dim createDictionary As Boolean
End Sub
Sub translate(params As String) As String
	Dim fg As fgen
	Dim widgets() As String = Regex.Split(";\s*",params)
	fg.Initialize
	For iw = 0 To widgets.Length - 1
		If fg.Left(widgets(iw),1) = "'" Or widgets(iw) = "" Then Continue	' comment
		Dim field() As String = Regex.Split(",", widgets(iw) & ",,,,,,*")
		field(field.Length-1) = ""		' remove *
		Dim wdgType As String = fg.normType.GetDefault(field(0).ToUpperCase,field(0).ToUpperCase)	' upper case and synonim
		If untraslate.ContainsKey(wdgType) Then Continue
		If pseudo.ContainsKey (wdgType) Then
			field(2) = getTrans(field(2))
		Else
			' label translation
			If field(2) = "" Then field(2) = field(1)
			field(2) = getTrans(field(2))
			Select wdgType
				Case "CKB"			' signal
				Case "QS","R","CMB","CMT","CMX"
					field(5) = splitKey(fg,field(5))
				Case Else			' text widgets
			End Select
		End If
		widgets(iw) = fg.implode(",",field)
	Next
	Return fg.implode(";",widgets)
End Sub
Sub splitKey(fg As fgen,data As String) As String ' split key value (combos, qualitative sliders AND option buttons)
	Dim dt() As String,k As Int
	dt = Regex.Split("\|", data)
	For j = 0 To dt.Length - 1
		k = dt(j).IndexOf(":")
		Dim translated As String = getTrans(dt(j).SubString(k+1))
		dt(j) = dt(j).Replace(dt(j).SubString(k+1),translated)
	Next
	Return fg.implode("|",dt)
End Sub
Sub getTrans(word As String) As String 
	Dim translated As String = dict.GetDefault(word,"")
	If translated = "" Then Log(word)
	Return dict.GetDefault(word,translated)
End Sub